
%%                                                           STAGrprof 4.02

%                                                 plots StagYY's rprof.dat
%    . calls f_designBackground
%    . calls f_dimParameter
%    . calls f_designFigure
%    . calls f_designLegend
%    . calls f_saveFigure
%    . calls f_startup
%    . calls f_varia
%                                               17.11.2016  Fabio Crameri

%% UPDATES 4.0
% *more stable design-routines*
% *cleaner plot design and layout*
% *automatic figure size*

%% UPDATES 3.0
% *improved plot layout*
% *improved code design*
% *option added for transparent legend background*
% *default variables added*

%% NOTES

function [PLOT] = STAGrprof(IN,PLOT,SWITCH,STYLE,SAVE)
if exist('IN','var') %if run from a parfile
    %% DEFAULT VARIABLES
    %...see f_defaultsRprof.m
else
    clear; clf;
    %% INPUT (...use parameter file instead)
    SAVE.StartNum = 1; SAVE.EndNum = 1;
    [IN,PLOT,SWITCH,STYLE,SAVE] = f_defaultsRprof; %get default variables
    IN.name         =   {  'test'  'test' };	% filename
    IN.number       =   [   2           3 	];
    IN.parameter    =   [   11      ];
    IN.folder       =   {   '/work/plotTest/'   };
end

%% STARTUP PROCEDURE
SAVE.app = 'STAGrprof'; SAVE.appVersion = 4.01;
if ~isfield(SAVE,'count'); SAVE.count = 0; end
[fAIo,SAVE,SWITCH] = f_startup(PLOT,SAVE,SWITCH);
if ~strcmp(fAIo.status,'all fine!'); disp(' '); disp(['                         ',char(10004),' Finished.']); return; end

%% GET NUMBER OF SUBPLOTS
nrPlots=0;
if PLOT.Temperature;            nrPlots = nrPlots+1; parameterX(nrPlots)=2;     log_xaxis(nrPlots)=IN.T_logx;       fieldString{nrPlots}='Temperature'; end
if PLOT.Heatflux;               nrPlots = nrPlots+1; parameterX(nrPlots)=NaN;   log_xaxis(nrPlots)=IN.HF_logx;      fieldString{nrPlots}='Heatflux'; end
if PLOT.Viscosity;              nrPlots = nrPlots+1; parameterX(nrPlots)=14;    log_xaxis(nrPlots)=IN.eta_logx;     fieldString{nrPlots}='Viscosity'; end
if PLOT.Stress;                 nrPlots = nrPlots+1; parameterX(nrPlots)=20;    log_xaxis(nrPlots)=IN.str_logx;     fieldString{nrPlots}='Stress'; end
if PLOT.StrainRate;             nrPlots = nrPlots+1; parameterX(nrPlots)=17;    log_xaxis(nrPlots)=IN.edot_logx;    fieldString{nrPlots}='Strainrate'; end
if PLOT.Crust;              	nrPlots = nrPlots+1; parameterX(nrPlots)=37;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Crust'; end
if PLOT.Air;                    nrPlots = nrPlots+1; parameterX(nrPlots)=43;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Air'; end
if PLOT.ContCrust;          	nrPlots = nrPlots+1; parameterX(nrPlots)=46;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Cont. Crust'; end
if PLOT.Primordial;             nrPlots = nrPlots+1; parameterX(nrPlots)=49;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Primordial'; end
if PLOT.Fluid;                  nrPlots = nrPlots+1; parameterX(nrPlots)=52;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Fluid'; end
if PLOT.Metal;                  nrPlots = nrPlots+1; parameterX(nrPlots)=55;    log_xaxis(nrPlots)=IN.c_logx;       fieldString{nrPlots}='Metal'; end
if PLOT.Velocity;               nrPlots = nrPlots+1; parameterX(nrPlots)=5;     log_xaxis(nrPlots)=IN.v_logx;       fieldString{nrPlots}='Velocity'; end
if PLOT.VerticalVelocity;       nrPlots = nrPlots+1; parameterX(nrPlots)=8;     log_xaxis(nrPlots)=IN.vz_logx;      fieldString{nrPlots}='Vertical Velocity'; end
if PLOT.HorizontalVelocity;     nrPlots = nrPlots+1; parameterX(nrPlots)=11;    log_xaxis(nrPlots)=IN.vh_logx;      fieldString{nrPlots}='Horizontal Velocity'; end
if PLOT.VertVorticity;      	nrPlots = nrPlots+1; parameterX(nrPlots)=23;	log_xaxis(nrPlots)=IN.w_logx;       fieldString{nrPlots}='Vert. Vorticity'; end
if PLOT.HorizVorticity;     	nrPlots = nrPlots+1; parameterX(nrPlots)=26;	log_xaxis(nrPlots)=IN.w_logx;       fieldString{nrPlots}='Horiz. Vorticity'; end
if PLOT.Divergence;          	nrPlots = nrPlots+1; parameterX(nrPlots)=29;	log_xaxis(nrPlots)=IN.div_logx;    	fieldString{nrPlots}='Divergence'; end
if PLOT.Density;                nrPlots = nrPlots+1; parameterX(nrPlots)=40;    log_xaxis(nrPlots)=IN.rho_logx;     fieldString{nrPlots}='Density'; end
if PLOT.Advection;              nrPlots = nrPlots+1; parameterX(nrPlots)=32;    log_xaxis(nrPlots)=IN.Hadv_logx; 	fieldString{nrPlots}='Thermal Advection'; end
if PLOT.Diffusion;              nrPlots = nrPlots+1; parameterX(nrPlots)=33;    log_xaxis(nrPlots)=IN.Hdiff_logx;   fieldString{nrPlots}='Thermal Diffusion'; end
if PLOT.InternalHeating;        nrPlots = nrPlots+1; parameterX(nrPlots)=34;    log_xaxis(nrPlots)=IN.Rh_logx;      fieldString{nrPlots}='Internal Heating'; end
if PLOT.ViscDissipation;        nrPlots = nrPlots+1; parameterX(nrPlots)=35;    log_xaxis(nrPlots)=IN.vd_logx;      fieldString{nrPlots}='Visc. Dissipation'; end
if PLOT.AdiabaticHeating;   	nrPlots = nrPlots+1; parameterX(nrPlots)=36;    log_xaxis(nrPlots)=IN.ah_logx;      fieldString{nrPlots}='Adiabatic Heating'; end

if PLOT.Toroidal;               nrPlots = nrPlots+1; parameterX(nrPlots)=58;    log_xaxis(nrPlots)=IN.To_logx;      fieldString{nrPlots}='Toroidal'; end
if PLOT.ToroidalRMS;            nrPlots = nrPlots+1; parameterX(nrPlots)=59;    log_xaxis(nrPlots)=IN.To_logx;      fieldString{nrPlots}='Toroidal_rms'; end
if PLOT.Poloidal;               nrPlots = nrPlots+1; parameterX(nrPlots)=60;    log_xaxis(nrPlots)=IN.Po_logx;      fieldString{nrPlots}='Poloidal'; end
if PLOT.PoloidalRMS;            nrPlots = nrPlots+1; parameterX(nrPlots)=61;    log_xaxis(nrPlots)=IN.Po_logx;      fieldString{nrPlots}='Poloidal_rms'; end
if PLOT.Mobility;               nrPlots = nrPlots+1; parameterX(nrPlots)=62;    log_xaxis(nrPlots)=IN.M_logx;       fieldString{nrPlots}='Mobility'; end
if PLOT.f80;                    nrPlots = nrPlots+1; parameterX(nrPlots)=63;    log_xaxis(nrPlots)=IN.f80_logx;     fieldString{nrPlots}='f80'; end
if PLOT.f90;                    nrPlots = nrPlots+1; parameterX(nrPlots)=64;    log_xaxis(nrPlots)=IN.f90_logx;     fieldString{nrPlots}='f90'; end

%% LAYOUT SUBPLOTS
if nrPlots<=4
    nxSubplots  = nrPlots;
    nzSubplots  = 1;
else
    nxSubplots  = floor((nrPlots+1)/2);
    nzSubplots  = min(nrPlots,2);
end

%% VARIABLE ADJUSTMENTS
nrModels = size(IN.name,2);
% check for length of number input arrays
if size(IN.parameter,2)<nrModels
    dummy = ones(1,nrModels-size(IN.parameter,2)); dummy(:) = IN.parameter(1,1);
    IN.parameter = [IN.parameter, dummy];
end
% check for length of string input arrays
if size(IN.folder,2)<nrModels
    dummy = cell(1,nrModels-size(IN.folder,2)); dummy(:) = IN.folder(1,1);
    IN.folder = [IN.folder, dummy];
end

%% FIGURE SETUP
clf(figure(1));
if strcmp(STYLE.colorMode,'light')
    STYLE.colorModeBW   = 'white';
elseif strcmp(STYLE.colorMode,'dark')
    STYLE.colorModeBW   = 'black';
    PLOT.ColorVector(:,:) = 1-PLOT.ColorVector(:,:);
end
set(gcf,'color',STYLE.colorModeBW);
% set figure position
FPOS.x          = 47;
FPOS.y          = 1;
% set figure width and height
if nzSubplots==1 && nxSubplots==1;          FPOS.size = [250 450];      %[1 1]
elseif nzSubplots==1 && nxSubplots==2;    	FPOS.size = [500 450];      %[1 2]
elseif nzSubplots==1 && nxSubplots==3;      FPOS.size = [750 450];      %[1 3]
elseif nzSubplots==1 && nxSubplots==4;      FPOS.size = [1000 450];      %[1 4]
elseif nzSubplots==2 && nxSubplots==3;      FPOS.size = [670 700];     %[2 3]
elseif nzSubplots==2 && nxSubplots==4;      FPOS.size = [893 700];     %[2 4]
elseif nzSubplots==2 && nxSubplots==5;      FPOS.size = [1120 700];	%[2 5]
elseif nzSubplots==2 && nxSubplots==6;      FPOS.size = [1340 700];	%[2 6]
else
    FPOS.size   = [1340 700]; %dummy
end
FPOS.position   = [FPOS.x FPOS.y FPOS.size(1,1) FPOS.size(1,2)];
set(gcf,'Position',FPOS.position); 

%% LOOP FILES
ymin_old = 1;
h_runs = zeros(size(IN.name,2),1); h_runsArea = h_runs;
for ifile=1:size(IN.name,2)
    clearvars -except IN SWITCH PLOT STYLE SAVE ...
        ifile fname_vector number_vector parameter_vector folder_vector ...
        save_string color_definition save_folder save_name h_runs h_runsArea ymin_old ...
        nrPlots parameterX log_xaxis fieldString nxSubplots nzSubplots
    
    FILE.name           = IN.name{ifile};
    FILE.number         = IN.number(ifile);
    folder              = IN.folder{ifile};
    SWITCH.parameter    = IN.parameter(ifile);
    line_color          = PLOT.ColorVector(ifile,:);
    
    %% CHECK FOR DIRECTORY
    folder_op       = strcat(folder,'+op/');
    folder_im       = strcat(folder,'+im/');
    FILE.directory  = [folder_op,FILE.name,'/']; %needed for f_dimParameter
    filestem        = strcat(folder_op,FILE.name,'/',FILE.name,'_rprof.dat');
    if ~exist(filestem,'file')
        disp(filestem)
        error('file not found: CHECK FILESTEM!')
    end
    
    %% RPROF.DAT FILE STRUCTURE
    %  1  2 3  4   5  6  7   8    9  10   11  12  13   14   15   16    17 18 19  20 21 22
    %  z,t0,t1,t2, v0,v1,v2, vz0,vz1,vz2, vh0,vh1,vh2, eta0,eta1,eta2, e0,e1,e2, s0,s1,s2,
    
    %  23 24 25 26 27 28  29 30 31  32   33  34    35        36          37 38 39
    %  w0,w1,w2,w3,w4,w5, d0,d1,d2, adv,diff,Rh,visc.diss,adiab.heating, c0,c1,c2
    
    %  56       57  58
    %  heatflux hf2 hf3
    
    %% OPEN FILE and check its length
    data1 = fopen(filestem,'r');
    %find #entries in one line automatically
    fgets(data1);              %reads empty line
    fgets(data1);              %reads header
    line = fgetl(data1);       %reads first line
    line = str2num(line);       %converts it to number
    numEntries = size(line,2); 	%number of entries
    frewind(data1);
    %find #lines automatically
    nLines = 0;
    cc = 0;
    while (fgets(data1) ~= -1)
        nLines = nLines+1;
        seek = fscanf(data1,'%8c',[1 1]);
        if strcmp(seek,'********')
            cc=cc+1;
            line_nr_set(cc) = nLines;
        end
    end
    frewind(data1);
    if numel(line_nr_set)==1
        error('needs at least 2 time steps!')
    elseif numel(line_nr_set)==2
        nz = line_nr_set(2)-line_nr_set(1)  -1;  %#data in z-direction
    else
        nz = line_nr_set(3)-line_nr_set(2)  -1;  %#data in z-direction
    end
    
    %% DISPLAY FILE DETAILS
    disp(['Name:              ',FILE.name])
    disp(['Number:            ',num2str(FILE.number)])
    if SWITCH.verbose
        % disp(['datafile is ',num2str(n),' x ',num2str(nLines)])
        disp(['Data Structure:       __',num2str(numEntries),'__>'])
        disp('                     |')
        disp(['                   ',num2str(nz)])
        disp('                     |')
        disp('                     V')
    end
    
    %% READING DATA
    %define plotted filenumber
    if FILE.number==9999
        FILE.number=cc;  %max. file number
    else
        FILE.number=FILE.number+1;  %chosen file number
    end
    %skip first line
    num_skip_lines = line_nr_set(FILE.number) ;
    %jump to given line number
    nLines = 0;
    %     cc = 0;
    while (fgets(data1)~=-1)
        nLines = nLines+1;
        if (nLines==num_skip_lines)
            break
        end
    end
    %read header
    line = fscanf(data1,'%s',[1 1]);
    i_time_step = fscanf(data1,'%i',[1 1]);   %time step
    line = fscanf(data1,'%s %s %s',[1 3]);
    time = fscanf(data1,'%f',[1 1]);   %time
    %read data
    wb = waitbar(0,'Please wait...');
    my_data = zeros(nz,numEntries)*NaN;
    for j=1:nz
        waitbar(j/nz,wb)
        line = fscanf(data1,'%e',[1 numEntries]);
        my_data(j,:)=line;
    end
    close(wb)
    fclose(data1);
    
    %% CHECK DETAILS OF INPUT FILE
    if max(my_data(:,1))>0.5 && max(my_data(:,1))<1.5  %if 0.5<D<1.5 then non-dimensional
        SWITCH.dimensionalInput = false; dimString = 'non-dimensional';
    else
        SWITCH.dimensionalInput = true; dimString = 'dimensional';
    end
    disp(['Data:              ',SWITCH.GeodynamicCode,', ',dimString])
    
    %% GET DIMENSIONAL PARAMETERS
    [SETUP,SWITCH] = f_dimParameter(SWITCH,FILE);
    
    %% GET SUITABLE DEPTH VECTOR DIMENSIONS
    if SWITCH.dim || SWITCH.dimensionalInput
        GRID.dimFactor      = SETUP.lengthscale;	%[m]
        %plotting variables
        if abs(max(my_data(:,1)*SETUP.lengthscale))>1e3 % >1km
            GRID.dimFactor  = GRID.dimFactor /1e3;	%[km]
            GRID.Zdim       = 'km';
        elseif abs(max(my_data(:,1)*SETUP.lengthscale))>1 % >1m
            GRID.dimFactor  = GRID.dimFactor;       %[m]
            GRID.Zdim       = 'm';
        else % <1m
            GRID.dimFactor = GRID.dimFactor *1e2;	%[cm]
            GRID.Zdim       = 'cm';
        end
    else
        GRID.ndFactor       = 1;                    %[nd]
        GRID.dimFactor      = GRID.ndFactor;        %[nd]
        GRID.Zdim           = 'nd';
    end
    
    %% SETUP DEPTH VECTOR
    %setup z-vector for grid cell tops or bottoms (e.g. vertical velocity)
    %  (is one value too large for rprof data, not sure if top or bottom.........)
    % my_data(1,1)	 => bottom   => z=0
    % my_data(end,1) => surface  => z=1
    dz_prof             = my_data(2:end,1) - my_data(1:end-1,1);
    dz_bot              = (my_data(1,1) - 0)*2;
    dz_top              = (1 - my_data(end,1))*2;
    dz_prof             = [dz_bot; dz_prof; dz_top]; %put additional dz for top and bottom boundary
    z_edge_prof_full    = my_data(:,1) - dz_prof(1:end-1,1)/2; %
    z_edge_prof_full    = [z_edge_prof_full; (z_edge_prof_full(end,1)+dz_prof(end,1))];  %z from 0 to 1
    %     z_edge_prof          = z_edge_prof_full(2:end,1);   %z from ~0 to 1 %grid cell interior values, like T and p
    
    %% SET MIN/MAX VARIABLE VALUES
    if SWITCH.dim || SWITCH.dimensionalInput
        zmin    = -500;     	zmax    = 3000;
        Tmin    = 0;            Tmax    = 2500;
        etamin  = 1e18;         etamax  = 1e29;
        edotmin = 1e-18;        edotmax = 1e-13;
        rhomin  = 2800;         rhomax  = 3400;
        strmin  = 0;            strmax  = 500;
        vmin    = 0;            vmax    = 3;
        Rhmin   = 0;            Rhmax   = 6e-12;
        hfmin   = 0;            hfmax   = 1000;
    else %non-dim
        zmin    = -0.05;     	zmax    = 0.95;
        Tmin    = 0;            Tmax    = 1;
        etamin  = 1e-4;         etamax  = 1e5;
        edotmin = 0;            edotmax = 7e4;
        rhomin  = -6e4;         rhomax  = 6e4;
        strmin  = 0;            strmax  = 7e4;
        vmin    = 0;            vmax    = 5000;
        Rhmin   = 0;            Rhmax   = 25;
        hfmin   = 0;            hfmax   = 0.5;
    end
    
    %% SETUP DATA DETAILS
    %   1                       2                       3                       4               5           6
    %  	name                    variable                dim. scale              dimension       min.value   max.value
    FIELD_M      = {
        'Depth'                 'z'                     GRID.dimFactor          GRID.Zdim       zmin        zmax        %1
        'Temperature'           'T_{mean}'           	SETUP.Tscale            SETUP.TDim      Tmin      	Tmax        %2
        'T1'                    'T_{min}'               SETUP.Tscale            SETUP.TDim      Tmin      	Tmax        %3
        'T2'                    'T_{max}'               SETUP.Tscale            SETUP.TDim      Tmin      	Tmax        %4
        'Velocity'              'v_{mean}'           	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %5
        'V1'                    'v_{min}'               SETUP.Vscale            SETUP.vDim      vmin       	vmax        %6
        'V2'                    'v_{max}'               SETUP.Vscale            SETUP.vDim      vmin       	vmax        %7
        'Vertical Velocity'     'vz_{mean}'           	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %8
        'Vz1'                   'vz_{min}'            	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %9
        'Vz2'                   'vz_{max}'           	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %10
        'Horizontal Velocity'   'vh_{mean}'          	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %11
        'Vh1'                   'vh_{min}'            	SETUP.Vscale            SETUP.vDim      vmin       	vmax        %12
        'Vh2'                   'vh_{max}'              SETUP.Vscale            SETUP.vDim      vmin       	vmax        %13
        'Viscosity'             '\eta_{mean}'           SETUP.etascale        	SETUP.etaDim 	etamin      etamax      %14
        'Eta1'                  '\eta_{min}'            SETUP.etascale        	SETUP.etaDim   	etamin      etamax      %15
        'Eta2'                  '\eta_{max}'            SETUP.etascale        	SETUP.etaDim   	etamin      etamax      %16
        'Strain Rate'           'UCvarepsilondot_{mean}' SETUP.edotscale       	SETUP.edotDim  	edotmin     edotmax     %17
        'E1'                    'UCvarepsilondot_{min}' SETUP.edotscale         SETUP.edotDim  	edotmin     edotmax     %18
        'E2'                    'UCvarepsilondot_{max}' SETUP.edotscale         SETUP.edotDim  	edotmin     edotmax     %19
        'Stress'                '\sigma_{mean}'         SETUP.stressscale       SETUP.stressDim	strmin      strmax      %20
        'S1'                    '\sigma_{min}'          SETUP.stressscale       SETUP.stressDim	strmin      strmax      %21
        'S2'                    '\sigma_{max}'          SETUP.stressscale       SETUP.stressDim	strmin      strmax      %22
        'Vert. Vorticity'    	'w_{h,mean}'           	SETUP.wscale        	SETUP.wDim      0           0.5         %23  ?
        'W1'                   	'w_{h,min}'           	SETUP.wscale        	SETUP.wDim      0           0.5         %24  ?
        'W2'                    'w_{h,max}'            	SETUP.wscale        	SETUP.wDim      0           0.5         %25  ?
        'Horiz. Vorticity'  	'w_{v,mean}'         	SETUP.wscale            SETUP.wDim      0           0.5         %26  ?
        'W4'                    'w_{v,min}'            	SETUP.wscale            SETUP.wDim      0           0.5         %27  ?
        'W5'                    'w_{v,max}'         	SETUP.wscale            SETUP.wDim      0           0.5         %28  ?
        'Divergence'          	'div_{mean}'         	SETUP.divscale      	SETUP.divDim	0           1e-2       	%29  ?
        'D1'                    'div_{min}'           	SETUP.divscale          SETUP.divDim	0           1e-2        %30  ?
        'D2'                    'div_{max}'           	SETUP.divscale       	SETUP.divDim	0           1e-2        %31  ?
        'Thermal Advection'    	'H_{adv}'               SETUP.HRscale        	SETUP.HRDim   	0           1           %32
        'Thermal Diffusion'    	'H_{diff}'              SETUP.HRscale         	SETUP.HRDim  	0           1           %33
        'Internal Heating'      'H_{int}'             	SETUP.Hscale         	SETUP.HDim      Rhmin       Rhmax       %34
        'Viscous Dissipation'  	'H_{diss}'           	SETUP.HRscale          	SETUP.HRDim   	0           1           %35
        'Adiabatic Heating'    	'H_{adi}'             	SETUP.HRscale         	SETUP.HRDim   	0           1           %36
        'Crust'                 'crust_{mean}'        	1                       '-'             0           1           %37
        'C1'                    'c1'                    1                       '-'             0           1           %38
        'C2'                    'c2'                    1                       '-'             0           1           %39
        'Density'            	'rho_{mean}'         	SETUP.rhoscale      	SETUP.rhoDim  	rhomin      rhomax      %40
        'Rho1'               	'rho_{min}'             SETUP.rhoscale          SETUP.rhoDim   	rhomin      rhomax      %41
        'Rho2'                 	'rho_{max}'             SETUP.rhoscale        	SETUP.rhoDim   	rhomin      rhomax      %42
        'Air'                 	'air_{mean}'         	1                       '-'             0           1         	%43
        'Air1'                  'air_{min}'            	1                       '-'             0           1        	%44
        'Air2'                 	'air_{max}'           	1                       '-'             0           1        	%45
        'Primordial'           	'prim_{mean}'       	1                       '-'             0           1        	%46
        'Prim1'                 'prim_{min}'        	1                       '-'             0           1       	%47
        'Prim2'                	'prim_{max}'           	1                       '-'             0           1           %48
        'Cont. Crust'        	'cc_{mean}'         	1                       '-'             0           1         	%49
        'Cc1'                   'cc_{min}'            	1                       '-'             0           1        	%50
        'Cc2'                 	'cc_{max}'           	1                       '-'             0           1        	%51
        'Fluids'               	'f_{mean}'              1                       '-'             0           1        	%52
        'F1'                    'f_{min}'               1                       '-'             0           1       	%53
        'F2'                	'f_{max}'           	1                       '-'             0           1           %54
        'Metal'               	'metal_{mean}'       	1                       '-'             0           1        	%55
        'Metal1'              	'metal_{min}'        	1                       '-'             0           1       	%56
        'Metal2'            	'metal_{max}'        	1                       '-'             0           1           %57
        ... %THIS IS OPTIONAL IN STAGYY
        'Toroidal prof'         'to'                    SETUP.Vscale            SETUP.vDim      vmin       	vmax        %58
        'Toroidal rms'          'to_{rms}'              SETUP.Vscale            SETUP.vDim      vmin       	vmax        %59
        'Poloidal prof'         'po'                    SETUP.Vscale            SETUP.vDim      vmin       	vmax        %60
        'Poloidal rms'        	'po_{rms}'              SETUP.Vscale            SETUP.vDim      vmin       	vmax        %61
        'Mobility (vrms)'       'm'                     1                       '-'             0           1           %62
        'Plateness (f80)'       'f80'                   1                       '-'             0           1           %63
        'Plateness (f90)'     	'f90'                   1                       '-'             0           1           %64
        ... %THIS IS CALCULATED LOCALLY IN STAGrprof
        'Heat Flux'             'hf_{mean}'             1                       'W/m'           hfmin       hfmax       %end-2
        'Hf1'                   'hf_{min}'              1                       'W/m'           hfmin       hfmax       %end-1
        'Hf2'                   'hf_{max}'              1                       'W/m'           hfmin       hfmax       %end
        };
    
    %% UNICODE VARIABLES
    %use the following character sequence to add unicode variables:
    %UCvarepsilondot => char(941)
    %UCvarepsilon => char(949)
    FIELD_M(:,2) = strrep(FIELD_M(:,2),'UCvarepsilondot',{char(941)}); %does only work if string consists ONLY of unicode character
    FIELD_M(:,2) = strrep(FIELD_M(:,2),'UCvarepsilon',{char(949)}); %does only work if string consists ONLY of unicode character
    
    %     zg(1,iz),(tprof(j,iz),j=1,3),(vprof(j,iz),j=1,3),(vzprof(j,iz),j=1,3),&
    %                       (vhprof(j,iz),j=1,3),(etaprof(j,iz),j=1,3),(eprof(j,iz),j=1,3)
    %                  write(1,'(38(1pe12.4))') (sprof(j,iz),j=1,3),((wprof(j,iz,k),j=1,3),k=1,2), &
    %                       (dprof(j,iz),j=1,3),(enprof(j,iz),j=1,5),(cprof(j,iz),j=1,3),(denprof(j,iz),j=1,3), &
    %                       (airprof(j,iz),j=1,3),(primprof(j,iz),j=1,3),(ccprof(j,iz),j=1,3),(fprof(j,iz),j=1,3), &
    %                       (metalprof(j,iz),j=1,3)
    
    % SET TIME
    PLOT.time       = time;     %[nd] or [dim]
    PLOT.time_dim   = time*SETUP.timescale/SETUP.secyear;  %get dimensional time [a]
    if PLOT.time_dim/1e6>100
        PLOT.time2plot = PLOT.time_dim/1e9; PLOT.time2plotDim = 'Ga'; PLOT.timeConvert = SETUP.timescale/SETUP.secyear/1e9;
    elseif PLOT.time_dim/1e6<1e-7 %0.0000001
        PLOT.time2plot = PLOT.time_dim*SETUP.secyear; PLOT.time2plotDim = 's'; PLOT.timeConvert = SETUP.timescale;
    elseif PLOT.time_dim/1e6<1e-4 %0.0001
        PLOT.time2plot = PLOT.time_dim; PLOT.time2plotDim = 'a'; PLOT.timeConvert = SETUP.timescale/SETUP.secyear;
    elseif PLOT.time_dim/1e6<1e-1 %0.1
        PLOT.time2plot = PLOT.time_dim/1e3; PLOT.time2plotDim = 'ka'; PLOT.timeConvert = SETUP.timescale/SETUP.secyear/1e3;
    else
        PLOT.time2plot = PLOT.time_dim/1e6; PLOT.time2plotDim = 'Ma'; PLOT.timeConvert = SETUP.timescale/SETUP.secyear/1e6;
    end
    if ~SWITCH.dim && ~SWITCH.dimensionalInput; PLOT.time2plot = PLOT.time; PLOT.time2plotDim = 'nd'; PLOT.timeConvert = 1; end

    % INDICATE TIME
    timeString0	= [num2str(PLOT.time,3),' | ',num2str(PLOT.time2plot,3),' ',PLOT.time2plotDim];
    if ~SWITCH.dim && ~SWITCH.dimensionalInput; timeString0	= num2str(PLOT.time,3); end
    timeString	= timeString0;
%     if ~isnan(PLOT.timeMT)
%         timeString = [timeString0,' | ',num2str(PLOT.timeMT,2),' mantle turnovers (vrms = ',num2str(v_rmsCurrent,2),', dt_MT = ',num2str(PLOT.dtMT,2),' ',PLOT.time2plotDim,')'];
%     end
    disp(['Time:              ',timeString])
    
    
    %% CALCULATE HEATFLUX FROM T-PROFILE
    if PLOT.Heatflux
        idxHeatflux     = size(FIELD_M,1)-2;
        if ~SWITCH.dim && ~SWITCH.dimensionalInput
            FIELD_M(idxHeatflux:idxHeatflux+2,4) = {'nd'};
            warning('Heatflux actually needs dimensional mode switched on!');
        end
            
        %adjust parameters calculated locally (due to optional rprof variables)
        parameterX(1,ismember(fieldString(:),'Heatflux')) = size(FIELD_M,1)-2;   %locate heatflux parameters as 3rd last entry
        
        z_vector                    = my_data(:,1);  %*dim_scale(PLOT.ParameterY);
        z_vector_gradient           = z_vector(2:end) - ( z_vector(2:end)-z_vector(1:end-1) )/2;  % z_new = z_old + dz/2
        z_vector_gradient(end+1)    = NaN; %max(z_vector_gradient);
        
        T_prof          = my_data(:,2)*FIELD_M{2,3};
        T_prof_min      = my_data(:,3)*FIELD_M{2,3};
        T_prof_max      = my_data(:,4)*FIELD_M{2,3};
        
        HF_prof         = SETUP.tcond_dimensional * ( T_prof(1:end-1) - T_prof(2:end) ); %calculate heat flux from temperature: Q = k*[T(z+1)-T(z)]  [W/m]  (upward positive)
        HF_prof_min     = SETUP.tcond_dimensional * ( T_prof_min(1:end-1) - T_prof_min(2:end) );
        HF_prof_max     = SETUP.tcond_dimensional * ( T_prof_max(1:end-1) - T_prof_max(2:end) );
        
        my_data(1:end-1,parameterX(strcmp(fieldString,'Heatflux'))) = HF_prof;          my_data(end,parameterX(strcmp(fieldString,'Heatflux'))) = NaN;
        my_data(1:end-1,parameterX(strcmp(fieldString,'Heatflux'))+1) = HF_prof_min;    my_data(end,parameterX(strcmp(fieldString,'Heatflux'))+1) = NaN;
        my_data(1:end-1,parameterX(strcmp(fieldString,'Heatflux'))+2) = HF_prof_max;    my_data(end,parameterX(strcmp(fieldString,'Heatflux'))+2) = NaN;
    end
    
    %% REVERSE Z-AXIS
    if IN.reverseYaxis
        if SWITCH.dimensionalInput
            max_z = SETUP.D;
        else
            max_z = 1.0;
        end
        my_data(:,1)    = max_z-my_data(:,1);
        %         z_edge_prof     = max_z-z_edge_prof; %need to take max_z for all z-data! %grid cell interior values, like T and p
        if PLOT.Heatflux; z_vector_gradient = max_z-z_vector_gradient; end
        my_data(:,1) = my_data(:,1)-SETUP.d_air;  %set actual depth, i.e., z=0 to rock-air interface
        %         z_edge_prof = z_edge_prof-SETUP.d_air;   %set z=0 to real surface %grid cell interior values, like T and p
        if PLOT.Heatflux; z_vector_gradient(:,1) = z_vector_gradient(:,1)-SETUP.d_air; end
    end
    
    %% PLOTTING
    num_subplot=0;
    hax = zeros(nrPlots,1);
    LeftmostSubplot = zeros(nrPlots,1);
    for iPlot=1:nrPlots
        plotParameterX      = parameterX(iPlot);
        plot_log_xaxis      = log_xaxis(iPlot);
        
        %check for separate min/max variables
        if plotParameterX<=31 || (plotParameterX>=37 && plotParameterX<=57) %separate min/max values available
            minmaxAvailable = true;
        else
            minmaxAvailable = false;
        end
        
        %choose appropriate z_vector:
        if strcmp(fieldString(iPlot),'Heatflux')
            plot_z_vector   = z_vector_gradient;  %for heat flux
        else
            %             if strcmp(fieldString(nr_loop),'vertical_velocity')
            %                 plot_z_vector = z_edge_prof; %grid cell interior values, like T and p
            %             else
            plot_z_vector = my_data(:,PLOT.ParameterY); %everything else
            %             end
        end
        
        %% SETUP FIGURE
        figure(1); hold on
        
        %% SETUP SUBPLOT
        if nrPlots>1
            num_subplot=num_subplot+1;
            hax(iPlot,1) = subplot(nzSubplots,nxSubplots,num_subplot);
        end
        if iPlot==1 || iPlot==nxSubplots+1
            LeftmostSubplot(iPlot,1) = true;
        end
        
        %% SETUP PLOT APPEARANCE
        if iPlot==1; IN.LineWidthPlot = IN.LineWidthPlot+0.1; end %wider first line
        
        %% DIMENSIONALISATION
        zData       = plot_z_vector *FIELD_M{PLOT.ParameterY,3};
        rmsData     = my_data(:,plotParameterX) *FIELD_M{plotParameterX,3};
        
        %% PLOT RMS LINE (and min/max lines)
        colourMax = [0.81 0.33 0.2];
        colourMin = [0.4 0.64 0.18];
        if plot_log_xaxis %LOGARITHMIC x_axis
            semilogx(rmsData,zData,'Color',line_color,'LineWidth',IN.LineWidthPlot); %needed to change x axis to semilogx
            if PLOT.parameterRange && minmaxAvailable
                minData = my_data(:,plotParameterX+1)*FIELD_M{plotParameterX,3};
                maxData = my_data(:,plotParameterX+2)*FIELD_M{plotParameterX,3};
                if PLOT.rangeAsArea
                    %logarithmic min/max area
                    edgecolor = 'none';
                    areaAlpha = 0.2;
                    hold on
                    pp4 = fill([maxData' fliplr(minData')],[zData' fliplr(zData')],...
                        line_color,'EdgeColor',edgecolor,'EdgeAlpha',areaAlpha,'FaceAlpha',areaAlpha);
                else
                    %logarithmic min/max lines
                    hold on
                    pp2 = semilogx(minData,zData,'Color',colourMin);
                    hold on
                    pp3 = semilogx(maxData,zData,'Color',colourMax);
                end
            end
            pp1 = semilogx(rmsData,zData,'Color',line_color,'LineWidth',IN.LineWidthPlot);
            
        else %NORMAL x_axis
            if PLOT.parameterRange && minmaxAvailable
                minData = my_data(:,plotParameterX+1)*FIELD_M{plotParameterX,3};
                maxData = my_data(:,plotParameterX+2)*FIELD_M{plotParameterX,3};
                if PLOT.rangeAsArea
                    %min-max area
                    edgecolor = 'none';
                    areaAlpha = 0.2;
                    hold on
                    pp4 = fill([maxData' fliplr(minData')],[zData' fliplr(zData')],...
                        line_color,'EdgeColor',edgecolor,'EdgeAlpha',areaAlpha,'FaceAlpha',areaAlpha);
                else
                    %min/max lines
                    hold on
                    pp2=plot(minData,zData,'Color',colourMin);
                    hold on
                    pp3=plot(maxData,zData,'Color',colourMax);
                end
            end
            pp1 = plot(rmsData,zData,'Color',line_color,'LineWidth',IN.LineWidthPlot);
        end
        
        %% INDIVIDUAL LEGENDS
        if PLOT.parameterRange && minmaxAvailable
            if PLOT.rangeAsArea
                h_runsArea(ifile,1) = pp4;
                if IN.showLegend
                    legend([pp1,pp4],[FIELD_M(plotParameterX,2),'Min-Max Area'],'Location','Best');
                end
            else %plot min/max as lines
                if IN.showLegend
                    legend([pp1,pp2,pp3],[FIELD_M(plotParameterX,2),FIELD_M(plotParameterX+1,2),FIELD_M(plotParameterX+2,2)],'Location','Best');
                end
            end
        else
            if IN.showLegend
                legend(pp1,FIELD_M(plotParameterX,2),'Location','Best');
            end
        end
        h_runs(ifile,1) = pp1;
        
        %% AXIS LABELLING
        FIELD.name          = FIELD_M{plotParameterX,1}; %just to be defined
        VARIA.xlabelName    = FIELD_M{plotParameterX,1};
        VARIA.xlabelDim     = FIELD_M{plotParameterX,4};
        VARIA.zlabelName    = FIELD_M{PLOT.ParameterY,1};
        VARIA.zlabelDim     = FIELD_M{PLOT.ParameterY,4};
        VARIA.task          = 'create annotation strings';
        [PLOT,VARIA] = f_varia(VARIA,FIELD,[],SWITCH,PLOT,STYLE,SAVE);
        xlabel(PLOT.xlabel)
        if SWITCH.simplify && ~LeftmostSubplot(iPlot,1)
            %no ylabel
        else
            ylabel(PLOT.ylabel);
        end
        
        %% AXIS SETTINGS
        grid on
        if IN.reverseYaxis
            axis ij
            ymin = min(plot_z_vector*FIELD_M{PLOT.ParameterY,3});
            ymax = max(plot_z_vector*FIELD_M{PLOT.ParameterY,3});
            if ymin<ymin_old
                set(gca,'YLim',[ymin ymax])
                if iPlot==nrPlots; ymin_old = ymin; end
            end
        end
        %constant axes
        if IN.constantAxis
            axis([FIELD_M{plotParameterX,5} FIELD_M{plotParameterX,6} zmin zmax]);
        else
            if ~plot_log_xaxis
                %check for sensible x-axis values - preventing 0.00001 values
                xMinMax = get(gca,'xlim');
                xminNearInt = round(xMinMax(1,1));
                xminDiffNearInt = abs(xMinMax(1,1)-xminNearInt);
                if xminDiffNearInt~=0 && xminDiffNearInt<(xMinMax(1,2)-xMinMax(1,1))/100 %100 is an arbitrary value
                    set(gca,'xlim',round(get(gca,'xlim')))
                end
            end
        end
        
        %% DISPLAY PARAMETER INFO
        if iPlot==1; disp('Maximum Values:'); end
        tabLength       = 20;
        lengthString    = size(fieldString{1,iPlot},2);
        whiteSpace(1,1:max(1,tabLength-lengthString)) = ' ';
        if minmaxAvailable %separate min/max values available
            disp(['   ',char(183),' ',fieldString{1,iPlot},whiteSpace,' = ',num2str(max(my_data(:,plotParameterX+2)*FIELD_M{plotParameterX,3}),3),' ',FIELD_M{plotParameterX,4}])
        else %no separate min/max values available
            disp(['   ',char(183),' ',fieldString{1,iPlot},whiteSpace,' = ',num2str(max(my_data(:,plotParameterX)*FIELD_M{plotParameterX,3}),3),' ',FIELD_M{plotParameterX,4}])
        end
        clearvars whiteSpace tabLength lengthString
        
        %% ADDITIONAL POSTPROCESSING
        if SWITCH.d_eta && strcmp(fieldString(iPlot),'Viscosity')
            topDepthLevel   = 500;
            botDepthLevel   = 2500;
            yyy             = my_data(:,PLOT.ParameterY)*FIELD_M{PLOT.ParameterY,3};
            xxx             = my_data(:,plotParameterX+1)*FIELD_M{plotParameterX,3};
            topValy         = min(yyy(yyy>topDepthLevel));
            topValx         = xxx(yyy==topValy);
            botValy         = max(yyy(yyy<botDepthLevel));
            botValx         = xxx(yyy==botValy);
            hold on
            indicatorColor = [0.1 0.2 0.9];
            if strcmp(STYLE.colorMode,'dark')
                indicatorColor = 1-indicatorColor;
            end
            plot([topValx botValx],[topValy botValy],'o','MarkerEdgeColor',indicatorColor)
            
            delta_visc          = botValx-topValx;
            delta_d             = botValy-topValy;
            gradient_eta        = delta_visc/delta_d*1000;
            gradient_etaMantle 	= delta_visc/delta_d*2890;
            d_etaFactor         = (botValx+(delta_visc/delta_d*(2890-botDepthLevel)))/topValx;
            d_etaOrdOfMag   	= (log10(botValx+(delta_visc/delta_d*(2890-botDepthLevel)))) - log10(topValx);
            
            text(topValx,botValy-(botValy-topValy)/2,{['\Delta\eta = ',num2str(gradient_eta,3),' Pas/1000km'];['\Delta\eta = ',num2str(d_etaOrdOfMag,2),' O.o.M.']},'Color',PLOT.ColorVector(1,:),'backgroundcolor',1-PLOT.ColorVector(1,:));
            disp(['(d_eta = ',num2str(gradient_eta,3),' Pas/1000km)']);
            disp(['(d_eta = ',num2str(gradient_etaMantle,3),' Pas/2890km)']);
            disp(['(d_eta = ',num2str(d_etaFactor,2),',  ',num2str(topValx,3),' <-> ',num2str(botValx+(delta_visc/delta_d*(2890-botDepthLevel)),3),')']);
            disp(['(d_eta = ',num2str(d_etaOrdOfMag,2),',  ',num2str(log10(topValx),3),' <-> ',num2str(log10(botValx+(delta_visc/delta_d*(2890-botDepthLevel))),3),' orders of magnitude)']);
        end
        %pause(0.5)
    end %loop
    
    %% GENERAL LABELLING
    %figure title
    if SWITCH.title
        figure(1); hold on
        axes('position',[0 0 1 1],'visible','off')
        text(0.5,0.97,['File number = ',num2str(FILE.number-1),'; Time step = ',num2str(i_time_step),'; Time = ',num2str(PLOT.time,3),' ',PLOT.time2plotDim],'HorizontalAlignment','center')
    end
    
    %% LOOP OUTPUT
    %     save_string = ([IN.saveString,FILE.name,'_',num2str(FILE.number-1),'_']);
    %pause(0.5)
    disp(' ')
end

%% LEGEND
if isfield(PLOT,'titleString'); legendANN = PLOT.titleString'; else; legendANN = IN.name'; end
for ientry=1:size(legendANN,1)
    dummy = ['RMS',' ',legendANN{ientry,1}];
    legendANN_full(1,ientry) = cellstr(dummy);
end

if PLOT.parameterRange && PLOT.rangeAsArea && h_runsArea(1,1)~=0
    for ientry=1:size(legendANN,1)
        dummy = ['Range',' ',legendANN{ientry,1}];
        legendANNrange(1,ientry) = cellstr(dummy);
    end
    dummy = [legendANN_full; legendANNrange];
    legendANN_combined = dummy(:)';
    dummy = [h_runs'; h_runsArea'];
    h_runs_combined = dummy(:)';
    hl = legend(h_runs_combined',legendANN_combined{:,:},'Location',PLOT.LegendLocation);
else
    hl = legend(h_runs,legendANN_full{:,:},'Location',PLOT.LegendLocation);
end
set(hl,'Interpreter','none');

%% STYLING
if SWITCH.stylePlots
    if SWITCH.styleLegend; STYLE.Legend = true; else; STYLE.Legend = false; end
    f_designFigure(STYLE);
end
if SWITCH.styleBackground
    BACK.ApplyTo    = 'all';          %'current', 'all'
    BACK.colorMode  = STYLE.colorMode;
    f_designBackground(BACK) %set plot background of each subplot
end

%% ANNOTATION
if SWITCH.annotation
    %     pause(0.5);
    f_designAnnotations(PLOT,STYLE);
end

%% SAVING PLOTS
if SAVE.Plot
    SAVE.Directory = strcat(folder_im,FILE.name,'/');
    if strcmp(STYLE.colorMode,'light')
        SAVE.blackBackground=0;
    elseif strcmp(STYLE.colorMode,'dark')
        SAVE.blackBackground=1;
    end
    if strcmp(STYLE.colorMode,'dark'); endix='_dark'; else; endix=''; end
    SAVE.FigureName = strcat(IN.saveString,endix);   %file name
    if SWITCH.dim
        SAVE.FigureName = strcat(SAVE.FigureName,'_DIM');
    end
    
    SAVE.FigureNr               = 1;
    SAVE.keepAspect             = logical(1);
    SAVE.jpgResolution       	= '-r500';
    
    f_saveFigure( SAVE )
end

%% FINISHING UP
disp(' ')
disp(['                         ',char(10004),' Finished.']);











