 
%%                                         CREATE INDIVIDUAL COLORMAPS 1.0
 
%                                                Fabio Crameri, 07.11.2012
clear

%% INPUT
name = 'bgwgr';            %name your colormap
% cd '~/ETH/Programming/MatLabProgs/colormaps/' %save directory
cd '~/Desktop/' %save directory 

saveAlsoForParaview = logical(0);

%% CREATE FIGURE
figure(1),clf
contourf(peaks)

%% CHOOSE INPUT COLORMAP TO ADJUST
% ***************
%SET INPUT COLORMAP:            %as a starting point for a new colormap
load('bgwgr.mat'); colormap((bgwgr)); %colormap(flipud(wgb));
% colormap(flipud(hot));
% acolor= [1 1 1; 0.5 0.5 0.5; 0.1 0.1 0.1]; colormap(acolor);
% colormap(hot)
% load('topo.mat','topomap1'); colormap(topomap1);
% ***************

colorbar

%% PAUSE TO ADJUST COLORMAP
% ***************
disp('Now adjust your colormap using the colormap editor and hit enter!')
pause  %adjust your own colormap using the editor
% ***************

%% SAVE COLORMAP
colormap_string = colormap(gca);
assignin('caller',name,colormap_string)
save(name,name)

if saveAlsoForParaview
% ***************
%saves xml files for paraview
scheme = name;

colors = eval(scheme);
N = length(colors);
fid = fopen([scheme '.xml'], 'w');
fprintf(fid, '<ColorMap name="%s" space="HSV">\n', scheme);
for i=1:N
x = [(i-1)/(N-1); colors(i,:)'];
fprintf(fid, '  <Point x="%f" o="1" r="%f" g="%f" b="%f"/>\n', x);
end
fwrite(fid, '</ColorMap>');
fclose(fid);
end

disp(['Colormap ',num2str(name),' created!'])

% ***************
%% INSTRUCTION TO USE IT
% to load the colormap "name" again, 
% make sure the file is in MatLabs search path and use:
% 
% load('name.mat'); colormap(name);
