
%%                                                 DEFAULT INPUT VARIABLES
%                                                          for STAGtimedat


function [IN,PLOT,SWITCH,STYLE,SAVE] = f_defaultsTimedat
if ~exist('STAGtimedat','file'); f_INSTALL; end

%% DEBUGGING
SWITCH.verbose                  =   logical(0);                 %switch for extended display output

%% INPUT FILE(S)
SWITCH.GeodynamicCode           =   'StagYY';                	%to use StagLab with a different code, run and adjust at locations of error messages
IN.name                         =   { 'test'  'test'	};   	% filename
IN.parameter                    =   [   11         ];
IN.folder                       =   {'/work/stagyy140211/'};

%% SAVING
SAVE.Plot                       =   logical(0);                 % saves plot directly to directory   
    SAVE.jpg                    =   logical(0); 
    SAVE.eps                    =   logical(0); 
    SAVE.pdf                    =   logical(0); 
    SAVE.png                    =   logical(1);
        SAVE.pngResolution      =   '-m4.0';
    IN.saveString               =   '+timePlot_';

%% DIMENSIONALISATION
SWITCH.dim                      =   logical(0);
    SWITCH.modelSetup           =   'standard';             	%see f_dimParameter, e.g., 'standard', 'solomatov2004'

%% STYLING
SWITCH.styleBackground          =   logical(1);
SWITCH.stylePlots               =   logical(1);
SWITCH.styleLegend              =   logical(1);
SWITCH.simplify                 =   logical(1);
%font
STYLE.AllFontName               =   'Open Sans';                %e.g. 'Helvetica','Corbel','Eurostyle','ETH Light','Open Sans'
STYLE.keyFontSize               =   10;
%colours
STYLE.colorMode                 =   'light';                    %'light' or 'dark' figure background
STYLE.keyColor                  =   [0.5 0.5 0.5];              %key colour used for text and axes

%% APP PERFORMANCE
IN.numWrite                     =   1;                          %CURRENTLY REMOVED! writes out every 'num_write' time step
IN.checkFileSize                =   logical(0);                 %checks for line number automatically (in case of a problem with data format)

%% PLOT ADDITIONS & LABELLING
SWITCH.parameterRange           =   logical(0);                 %plotting mean, min & max
   	PLOT.rangeAsArea            =   logical(1);                 %min/max range as area
    SWITCH.MinMaxLegend         =   logical(0);                 %legend switch for min and max lines

%% ANNOTATION
SWITCH.annotation               =   logical(1);
    STYLE.annotationLocation    =   'botLeft';                  %'topOutTop','topOutCorner','topLeft','botLeft','topRight','botRight'
    PLOT.annotation             =   {'a' 'b' 'c' 'd' 'e' 'f' 'g' 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' 'p'};  %subplot annotation strings
    PLOT.annIfMoreThanOne       =   logical(1);                 %add annotation only if more than 1 subplot

%% PARAMETER(S) TO PLOT
PLOT.Temperature                =   logical(1);
PLOT.Viscosity                  =   logical(1);
PLOT.Velocity                   =   logical(1);
PLOT.Composition                =   logical(0);

PLOT.Ra_eff                     =   logical(1);   %only 1 value
PLOT.Nu_top                     =   logical(0);   %only 1 value
PLOT.Nu_bot                     =   logical(0);   %only 1 value
PLOT.InternalHeating            =   logical(1);   %only 1 value
PLOT.HeatfluxTop                =   logical(0);   %only 1 value
PLOT.HeatfluxBot                =   logical(0);   %only 1 value
PLOT.EruptionRate               =   logical(0);   %only 1 value
PLOT.EruptHeatFlux              =   logical(0);   %only 1 value
PLOT.Erupta                     =   logical(0);   %only 1 value
PLOT.Entrainment                =   logical(0);   %only 1 value
PLOT.Cmass_error                =   logical(0);   %only 1 value
PLOT.Timesteps                  =   logical(0);   %only 1 value
PLOT.Performance                =   logical(1);   %only 1 value
    
%% COLOUR SET FOR MULTIPLE LINES
PLOT.ColorVector                = [ 
    0.0 0.0 0.0
    0.0 0.45 0.74
    0.49 0.18 0.56
    0.85 0.32 0.1
    0.93 0.69 0.13
    1.0 0.0 1.0
    0.0 0.0 0.0
    0.0 0.0 0.0
    0.0 0.0 0.0
    0.0 0.0 0.0
    ];


end









